/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.5.A, Date: 28-Aug-2008.
 * Copyright (c) 2003-2018 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "rtxsrc/OSRTFileInputStream.h"
#include "rtxmlsrc/rtXmlCppMsgBuf.h"
#include "fpml-main-4-4.h"

int main (int argc, char** argv)
{
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;

   // Process command line arguments

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-i")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: reader [-v] [-i <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -i <filename>  read encoded msg from <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   // Create buffer and control objects

   ::Document* pValue = 0;
   OSRTFileInputStream in (filename);
   OSXMLDecodeBuffer decodeBuffer (in);

   if (decodeBuffer.getStatus ()) {
      decodeBuffer.printErrorInfo();
      return decodeBuffer.getStatus ();
   }

   FpML_CC pdu (decodeBuffer);

   decodeBuffer.setDiag (verbose);

   // Decode

   stat = pdu.decode();

   if (0 == stat) {
      pValue = pdu.getValue();
      if (trace) {
         printf ("decoded XML message:\n");
         pdu.print ("FpML");
         printf ("\n");
      }
   }
   else {
      printf ("Decoding failed\n");
      decodeBuffer.printErrorInfo();
      pValue = pdu.getValue();
      delete pValue;
      return stat;
   }

   delete pValue;
   return 0;
}
